/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef VIEWMODEL_H
#define VIEWMODEL_H

#include<gtkmm.h>
#include"mainwindow.h"

class MonthCalendarColumns : public Gtk::TreeModel::ColumnRecord
{
public:

  MonthCalendarColumns()
	{ 
        for(int i=0; i<7; i++) {
            add(day[i]);
            add(date[i]);
            add(bgColors[i]);
            add(fgColors[i]);
            add(focused[i]);
        }
    }

    Gtk::TreeModelColumn<Glib::ustring> day[7];
    Gtk::TreeModelColumn<Glib::Date> date[7];
    Gtk::TreeModelColumn<Gdk::Color> bgColors[7];
    Gtk::TreeModelColumn<Gdk::Color> fgColors[7];
    Gtk::TreeModelColumn<bool> focused[7];
};

class MonthCalendarModel : public Gtk::ListStore {
    public:
        MonthCalendarModel(MonthCalendarColumns * calendarColumns);
        void initialize(PCalMainWindow * mv);
        // this function actually rebuilds the model content
        // for the date specified
        void jumpTo(const Glib::Date date, const bool force_refresh = false);

        // refresh the tree view
        void refresh();
    
        // set the new today date (if the midnight passed)
        void setToday(const Glib::Date date);
    
        void updateSelection();
    
        Glib::Date current_date;
        Glib::Date todayDate;
    
        MonthCalendarColumns * columns;
    private:
        PCalMainWindow * mainWindow;
        PCalOptions * calOptions;
        bool updateRowSelections(const Gtk::TreeModel::Path& path,
	                                const Gtk::TreeModel::iterator& iter);
};

#endif // VIEWMODEL_H
